import React from 'react';

class PACK extends React.Component{
   constructor(props){
     super(props) 
     this.renderD3Component = this.renderD3Component.bind(this)
   }
  
   renderD3Component(){
       const render = PackComponent(this.node,
                                    { sum: d=> d.sample,
                                      sort:(a, b) => b.sample - a.sample,
                                      key: d=> d.name
                                     },
                                   )
       render(this.props.data)
   }
  
   componentDidMount(){
        this.renderD3Component()
   }
  
   componentDidUpdate(){
        this.renderD3Component()
   }
   
   render(){
     return (<svg viewBox = '0 0 400 400' ref = { node => this.node = node }>
            </svg>);   
   }
  
} 
export default PACK;

import { select,
         pack,
         hierarchy,
         nest,
         scaleSequential,
         interpolateMagma,
         scaleOrdinal,
         range
       } from 'd3'

const PackComponent = (selection,props) => {
  
  
       const render = (data) => {
         
            console.log(data)
           
            let dim = select(selection).attr('viewBox')
            
            dim = dim.split(' ').map(d=>+d).slice(2)
         
            const height = dim[0]
            const width = dim[1]
         
            const circle =    pack()
                  .size([dim[0] - 2, dim[1] - 2])
                  .padding(3)
            
            const metaData = hierarchy(data).sum(props.sum)
            														.sort(props.sort)
            
 
            const metaCircleData = circle(metaData)
            
          
            const names = metaCircleData.descendants()
              						 .map(d => d.data)
              					  .filter( d=> !d.children )
                          .map(props.key)
            
            const clip =scaleOrdinal().domain(names).range(range(names.length))
            
            
            const drawCircleData = nest().key(d => d.height).entries(metaCircleData.descendants())
            
            const table = drawCircleData.filter(x=> x.key== 0)[0]
            														.values
                                        .map(d => d.data)
                                        .map(d=> d.name)
            
            const id = scaleOrdinal().domain(table).range(range(table.length))
            
            const im_offset = scaleOrdinal().domain(table)
            
       
            drawComponent(drawCircleData,id,width,metaCircleData)
           
       }
     
       
       
       const drawComponent = (data,id,width,metaCircleData) => {
         
           const root = metaCircleData;
           
           let focus = metaCircleData;
         
           let view;
         
           view = root;
         
         
           const node = select(selection).selectAll("g")
                .data(data)
                .enter().append("g")
                .selectAll("g")
                .data(d => d.values)
                .enter().append("g")
                  .attr("transform", d => `translate(${d.x + 1},${d.y + 1})`)
            
           const color = scaleSequential([8, 0], interpolateMagma)
           
           
           node.append("circle")
                .attr("r", d => d.r)
                .attr("fill", d => color(d.height))
                .on('click',event => { console.log(event) })
         
    
   
           const zoomTo = (v) => {
               console.log('view',v)
               view = v
               const k = width/v[2];
               node.attr("transform", d => `translate(${(d.x - v[0]) * k + 200},${(d.y - v[1]) * k + 200})`);
               node.select('circle').attr("r", d => d.r * k);
               node.filter(d => !d.children)
                   .select('defs')
                   .select('clipPath')
                   .select('circle').attr("r", d => d.r * k);
             
               node.filter(d => !d.children)
                   .select('image')
                   .attr('height',d=>2*d.r*k)
                   .attr('x',d=>{console.log(+d.data.offset);return -d.r*k +(+d.data.offset)})
                   .attr('y',d=>-d.r*k )
           }
           
           
           const zoom = (d) => {
                const focus0 = focus
                focus = d;
                const transition = select(selection).transition()
                                       .duration( 750)
                                       .tween("zoom", d => {
                                        const i = d3.interpolateZoom(view, [focus.x, focus.y, focus.r * 2]);
                                        return t => zoomTo(i(t));
                                      });
           }
           
           
           zoomTo([root.x, root.y, root.r * 2 ]);
         
           const branch = node.filter(d=>d.children)
                .on("mouseover", function() {
                  
                   d3.select(this).select('circle').attr("stroke", "#000");
                
                })
                .on("mouseout", function() { 
                  
                  d3.select(this).select('circle').attr("stroke", null); 
                })
                .on("click", (d) => focus !== d && (zoom(d), event.stopPropagation()));
         
         
           const leaf = node.filter(d => !d.children);
         
          // leaf.select('circle[fill]').remove();
           leaf.append('defs')
               .append('clipPath')
               .attr('id',d => id(d.data.name))
               .append('circle')
                 .attr("r", d =>{ 
                 return d.r;
               })
         
         
           leaf.append('image')
               .attr('href',d=>d.data.link)
               .attr('height',d=>2*d.r)
               .attr('x',d=>{return -d.r +(+d.data.offset)})
               .attr('y',d=>-d.r)
               .attr('clip-path',d =>`url(#${id(d.data.name)})`)
         
         
           branch.append('text')
                 .text(d =>d.data.name)
                 .attr('y',d => -0.8*d.r  )
                 .attr('x', d => -0.8*d.r  )
         
         
           branch.select('circle')
                 .style('fill-opacity',0.4)
         
           
          
       }
       
       return render;
}

